## netavark 1.4.0

=== Makefile ===
# This Makefile is intended for developer convenience.  For the most part
# all the targets here simply wrap calls to the `cargo` tool.  Therefore,
# most targets must be marked 'PHONY' to prevent `make` getting in the way
#
#prog :=xnixperms

DESTDIR ?=
PREFIX ?= /usr/local
LIBEXECDIR ?= ${PREFIX}/libexec
LIBEXECPODMAN ?= ${LIBEXECDIR}/podman

SELINUXOPT ?= $(shell test -x /usr/sbin/selinuxenabled && selinuxenabled && echo -Z)
# Get crate version by parsing the line that starts with version.
CRATE_VERSION ?= $(shell grep ^version Cargo.toml | awk '{print $$3}')
GIT_TAG ?= $(shell git describe --tags)

# Set this to any non-empty string to enable unoptimized
# build w/ debugging features.
debug ?=

# All complication artifacts, including dependencies and intermediates
# will be stored here, for all architectures.  Use a non-default name
# since the (default) 'target' is used/referenced ambiguously in many
# places in the tool-chain (including 'make' itself).
CARGO_TARGET_DIR ?= targets
export CARGO_TARGET_DIR  # 'cargo' is sensitive to this env. var. value.

ifdef debug
$(info debug is $(debug))
  # These affect both $(CARGO_TARGET_DIR) layout and contents
  # Ref: https://doc.rust-lang.org/cargo/guide/build-cache.html
  release :=
  profile :=debug
else
  release :=--release
  profile :=release
endif

.PHONY: all
all: build

bin:
	mkdir -p $@

$(CARGO_TARGET_DIR):
	mkdir -p $@

.PHONY: build
build: bin $(CARGO_TARGET_DIR)
	cargo build $(release)
	cp $(CARGO_TARGET_DIR)/$(profile)/netavark bin/netavark$(if $(debug),.debug,)

.PHONY: crate-publish
crate-publish:
	@if [ "$(CRATE_VERSION)" != "$(GIT_TAG)" ]; then\
		echo "Git tag is not equivalent to the version set in Cargo.toml. Please checkout the correct tag";\
		exit 1;\
	fi
	@echo "It is expected that you have already done 'cargo login' before running this command. If not command may fail later"
	cargo publish --dry-run
	cargo publish

.PHONY: clean
clean:
	rm -rf bin
	if [ "$(CARGO_TARGET_DIR)" = "targets" ]; then rm -rf targets; fi
	$(MAKE) -C docs clean

.PHONY: docs
docs: ## build the docs on the host
	$(MAKE) -C docs

.PHONY: install
install:
	install ${SELINUXOPT} -D -m0755 bin/netavark $(DESTDIR)/$(LIBEXECPODMAN)/netavark
	$(MAKE) -C docs install

.PHONY: uninstall
uninstall:
	rm -f $(DESTDIR)/$(LIBEXECPODMAN)/netavark
	rm -f $(PREFIX)/share/man/man1/netavark*.1

.PHONY: test
test: unit integration

# Used by CI to compile the unit tests but not run them
.PHONY: build_unit
build_unit: $(CARGO_TARGET_DIR)
	cargo test --no-run

.PHONY: unit
unit: $(CARGO_TARGET_DIR)
	cargo test

.PHONY: integration
integration: $(CARGO_TARGET_DIR)
	# needs to be run as root or with podman unshare --rootless-netns
	bats test/

.PHONY: validate
validate: $(CARGO_TARGET_DIR)
	cargo fmt --all -- --check
	cargo clippy -p netavark -- -D warnings

.PHONY: vendor-tarball
vendor-tarball: build install.cargo-vendor-filterer
	VERSION=$(shell bin/netavark --version | cut -f2 -d" ") && \
	cargo vendor-filterer '--platform=*-unknown-linux-*' --format=tar.gz --prefix vendor/ && \
	mv vendor.tar.gz netavark-v$$VERSION-vendor.tar.gz && \
	gzip -c bin/netavark > netavark.gz && \
	sha256sum netavark.gz netavark-v$$VERSION-vendor.tar.gz > sha256sum

.PHONY: install.cargo-vendor-filterer
install.cargo-vendor-filterer:
	cargo install cargo-vendor-filterer

.PHONY: mock-rpm
mock-rpm:
	rpkg local

.PHONY: help
help:
	@echo "usage: make $(prog) [debug=1]"

## netavark 1.0.3

=== debian/changelog ===
netavark (1.0.3-3) unstable; urgency=medium

  * Provides: container-network-stack = 2, following the Fedora versioning
    scheme for the network stack replacement.

 -- Reinhard Tartler <siretart@tauware.de>  Fri, 05 Aug 2022 14:13:51 +0200

netavark (1.0.3-2) unstable; urgency=medium

  * install the netavark binary to the correct location
  * bump standards version

 -- Reinhard Tartler <siretart@tauware.de>  Fri, 05 Aug 2022 00:01:19 +0200

netavark (1.0.3-1) unstable; urgency=medium

  * Initial release (Closes: #1009713)

 -- Reinhard Tartler <siretart@tauware.de>  Sun, 24 Jul 2022 01:08:23 -0400

=== debian/control ===
Source: netavark
Section: net
Priority: optional
Maintainer: Reinhard Tartler <siretart@tauware.de>
Build-Depends: debhelper-compat (= 13),
 dh-cargo (>= 25),
 cargo:native <!nocheck>,
 librust-anyhow-dev,
 librust-atty-dev,
 librust-chrono-dev,
 librust-clap+derive-dev,
 librust-env-logger-dev (>> 0.9),
 librust-futures-dev,
 librust-humantime-dev,
 librust-ipnet+serde-dev,
 librust-iptables-dev,
 librust-libc-dev,
 librust-log-dev,
 librust-netlink-packet-route-dev,
 librust-nix-dev,
 librust-rand-dev,
 librust-rtnetlink-dev,
 librust-serde+derive-dev,
 librust-serde-json-dev,
 librust-serde-value-dev,
 librust-sha2-dev,
 librust-simple-error-dev,
 librust-strsim-dev,
 librust-sysctl-dev,
 librust-termcolor-dev,
 librust-tokio+full-dev,
 librust-url-dev,
 librust-zbus-dev,
 librust-zvariant-dev,
 libstd-rust-dev <!nocheck>,
 rustc:native <!nocheck>,
Standards-Version: 4.6.1
Homepage: https://github.com/containers/netavark
Vcs-Browser: https://salsa.debian.org/debian/netavark
Vcs-Git: https://salsa.debian.org/debian/netavark.git
Rules-Requires-Root: no

Package: netavark
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Provides: container-network-stack (= 2)
Enhances: podman
Description: Rust based network stack for containers
 Netavark is designed to work with but is also applicable
 for other OCI container management applications.

## netavark 1.4.0

=== debian/changelog ===
netavark (1.4.0-3) unstable; urgency=medium

  * Install aardvark-dns by default with netavark
  * Allow netavark to find aardvark-dns by default, Closes: #1030302

 -- Reinhard Tartler <siretart@tauware.de>  Fri, 03 Feb 2023 06:31:00 -0500

netavark (1.4.0-2) unstable; urgency=medium

  [ Peter Michael Green ]
  * Update debian dependency on clap to match cargo dependency,
    closes: #1028657

  [ Reinhard Tartler ]
  * Upload to unstable

 -- Reinhard Tartler <siretart@tauware.de>  Sat, 14 Jan 2023 07:49:05 -0500

netavark (1.4.0-1) unstable; urgency=medium

  * New upstream release
  * Allow cross-compilation by relaxing build-dep on libstd-rust-dev,
    Closes: #1025361
  * Bug fix: "FTBFS: dh_auto_test: error: /usr/share/cargo/bin/cargo build
    returned exit code 101", thanks to Lucas Nussbaum (Closes: #1027624).
  * Break on older versions of aardvark-dns, the must match minor versions.
  * Invoke test suite

 -- Reinhard Tartler <siretart@tauware.de>  Mon, 02 Jan 2023 08:45:36 -0500

netavark (1.0.3-4) unstable; urgency=medium

  * Fix FTBFS, bump nix version, thanks to Lucas Nussbaum (Closes: #1020122).

 -- Reinhard Tartler <siretart@tauware.de>  Wed, 19 Oct 2022 16:22:07 -0400

=== debian/control ===
--- 
+++ 
@@ -8,9 +8,10 @@
  librust-anyhow-dev,
  librust-atty-dev,
  librust-chrono-dev,
- librust-clap+derive-dev,
+ librust-clap-3+derive-dev (>= 3.2.23),
  librust-env-logger-dev (>> 0.9),
  librust-futures-dev,
+ librust-fs2-dev,
  librust-humantime-dev,
  librust-ipnet+serde-dev,
  librust-iptables-dev,
@@ -30,9 +31,9 @@
  librust-termcolor-dev,
  librust-tokio+full-dev,
  librust-url-dev,
- librust-zbus-dev,
+ librust-zbus-dev (>= 1.9.2-4),
  librust-zvariant-dev,
- libstd-rust-dev <!nocheck>,
+ libstd-rust-dev,
  rustc:native <!nocheck>,
 Standards-Version: 4.6.1
 Homepage: https://github.com/containers/netavark
@@ -44,6 +45,8 @@
 Architecture: any
 Depends: ${shlibs:Depends}, ${misc:Depends}
 Provides: container-network-stack (= 2)
+Recommends: aardvark-dns
+Breaks: aardvark-dns (<< 1.4)
 Enhances: podman
 Description: Rust based network stack for containers
  Netavark is designed to work with but is also applicable

=== debian/rules ===
#!/usr/bin/make -f

# generate cargo-checksum file
_mkchecksum = printf '{"package":"%s","files":{}}\n' \
 $$(sha256sum $(or $2,$(dir $1)Cargo.toml) | grep -Po '^\S+') > $1;

%:
	dh $@ --buildsystem cargo

execute_before_dh_auto_configure:
	$(call _mkchecksum,debian/cargo-checksum.json,Cargo.toml)

execute_after_dh_install:
	mkdir -vp debian/netavark/usr/lib
	mv -v debian/netavark/usr/bin debian/netavark/usr/lib/podman

=== debian/tests/control ===
Test-Command: env NETAVARK=/usr/lib/podman/netavark bats test/
Depends: @, bats, jq, util-linux, iptables, netcat-traditional, firewalld
Restrictions: allow-stderr, needs-root, flaky

## netavark 1.6.0

=== debian/changelog ===
netavark (1.6.0-1ubuntu1) noble; urgency=medium

  * New upstream release (LP: #2063447)
  * Vendor package since rust-zbus is unavailable
  * Use gnome-snapshot's debian/README.source as a vendoring guide
  * Update Build-Depends

 -- Jeremy Bícha <jbicha@ubuntu.com>  Thu, 25 Apr 2024 08:18:05 -0400

netavark (1.6.0-1) experimental; urgency=medium

  * New upstream release

 -- Reinhard Tartler <siretart@tauware.de>  Tue, 16 Apr 2024 07:00:05 -0400

netavark (1.4.0-4) unstable; urgency=medium

  [ Peter Michael Green ]
  * Apply upstream patches for new netlink crates. (Closes: #1042194)
  * Bump env-logger dependency.
  * Stop patching zbus cargo dependency and update debian dependency, Debian
    now has zbus 3.x

  [ Reinhard Tartler ]
  * Refresh patches
  * Upload to unstable as maintainer upload

 -- Reinhard Tartler <siretart@tauware.de>  Wed, 06 Sep 2023 18:46:22 -0400

=== debian/control ===
Source: netavark
Section: net
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Reinhard Tartler <siretart@tauware.de>
Build-Depends: debhelper-compat (= 13),
 dh-cargo (>= 25),
 cargo:native <!nocheck>,
 libstd-rust-dev,
 protobuf-compiler,
 rustc:native <!nocheck>,
Standards-Version: 4.6.1
XS-Vendored-Sources-Rust: aho-corasick@1.1.3, android_system_properties@0.1.5, anyhow@1.0.70, arrayvec@0.7.2, async-broadcast@0.5.1, async-channel@1.8.0, async-executor@1.5.0, async-fs@1.6.0, async-io@1.12.0, async-lock@2.7.0, async-recursion@1.0.2, async-stream-impl@0.3.5, async-stream@0.3.5, async-task@4.3.0, async-trait@0.1.68, atomic-waker@1.1.0, atty@0.2.14, autocfg@1.1.0, axum-core@0.3.3, axum@0.6.12, base64@0.21.0, bitflags@1.3.2, block-buffer@0.10.3, blocking@1.3.0, bumpalo@3.12.0, byteorder@1.4.3, bytes@1.4.0, cc@1.0.79, cfg-if@1.0.0, chrono@0.4.24, clap@3.2.23, clap_derive@3.2.18, clap_lex@0.2.4, codespan-reporting@0.11.1, concurrent-queue@2.1.0, core-foundation-sys@0.8.3, cpufeatures@0.2.5, crossbeam-utils@0.8.15, crypto-common@0.1.6, cxx-build@1.0.92, cxx@1.0.92, cxxbridge-flags@1.0.92, cxxbridge-macro@1.0.92, data-encoding@2.3.3, derivative@2.2.0, dhcproto-macros@0.1.0, dhcproto@0.9.0, digest@0.10.6, dirs-sys@0.3.7, dirs@4.0.0, either@1.8.1, enum-as-inner@0.5.1, enumflags2@0.7.5, enumflags2_derive@0.7.4, env_logger@0.10.0, equivalent@1.0.1, errno-dragonfly@0.1.2, errno@0.2.8, etherparse@0.13.0, ethtool@0.2.4, event-listener@2.5.3, fastrand@1.9.0, fixedbitset@0.4.2, fnv@1.0.7, form_urlencoded@1.1.0, fs2@0.4.3, futures-channel@0.3.28, futures-core@0.3.28, futures-executor@0.3.26, futures-io@0.3.28, futures-lite@1.12.0, futures-macro@0.3.28, futures-sink@0.3.28, futures-task@0.3.28, futures-util@0.3.28, futures@0.3.26, generic-array@0.14.6, genetlink@0.2.4, getrandom@0.2.8, h2@0.3.26, hashbrown@0.12.3, hashbrown@0.14.3, heck@0.4.1, hermit-abi@0.1.19, hermit-abi@0.2.6, hermit-abi@0.3.1, hex@0.4.3, http-body@0.4.5, http@0.2.9, httparse@1.8.0, httpdate@1.0.2, humantime@2.1.0, hyper-timeout@0.4.1, hyper@0.14.28, iana-time-zone-haiku@0.1.1, iana-time-zone@0.1.53, idna@0.2.3, idna@0.3.0, indexmap@1.9.2, indexmap@2.2.6, instant@0.1.12, io-lifetimes@1.0.5, ipnet@2.7.2, iptables@0.5.0, is-terminal@0.4.4, itertools@0.10.5, itoa@1.0.6, js-sys@0.3.61, lazy_static@1.4.0, libc@0.2.140, link-cplusplus@1.0.8, linux-raw-sys@0.1.4, log@0.4.17, macaddr@1.0.1, matches@0.1.10, matchit@0.7.0, memchr@2.5.0, memoffset@0.6.5, memoffset@0.7.1, mime@0.3.16, mio@0.8.6, mozim@0.2.2, mptcp-pm@0.1.2, multimap@0.8.3, netlink-packet-core@0.5.0, netlink-packet-core@0.7.0, netlink-packet-generic@0.3.2, netlink-packet-route@0.15.0, netlink-packet-route@0.17.1, netlink-packet-utils@0.5.2, netlink-proto@0.11.1, netlink-sys@0.8.5, nispor@1.2.10, nix@0.23.2, nix@0.26.2, num-integer@0.1.45, num-traits@0.2.15, num_cpus@1.15.0, once_cell@1.17.1, ordered-float@2.10.0, ordered-stream@0.2.0, os_str_bytes@6.4.1, parking@2.0.0, paste@1.0.12, percent-encoding@2.2.0, petgraph@0.6.3, pin-project-internal@1.0.12, pin-project-lite@0.2.9, pin-project@1.0.12, pin-utils@0.1.0, polling@2.5.2, ppv-lite86@0.2.17, prettyplease@0.2.9, proc-macro-crate@1.3.1, proc-macro-error-attr@1.0.4, proc-macro-error@1.0.4, proc-macro2@1.0.81, prost-build@0.12.4, prost-derive@0.12.4, prost-types@0.12.4, prost@0.12.4, quote@1.0.26, rand@0.8.5, rand_chacha@0.3.1, rand_core@0.6.4, redox_syscall@0.2.16, redox_users@0.4.3, regex-automata@0.3.7, regex-syntax@0.7.5, regex@1.9.4, rtnetlink@0.12.0, rustix@0.36.9, rustversion@1.0.12, ryu@1.0.13, same-file@1.0.6, scratch@1.0.5, serde-value@0.7.0, serde@1.0.159, serde_derive@1.0.159, serde_json@1.0.95, serde_repr@0.1.11, sha1@0.10.5, sha2@0.10.6, signal-hook-registry@1.4.1, slab@0.4.8, smallvec@1.10.0, socket2@0.4.9, static_assertions@1.1.0, strsim@0.10.0, syn@1.0.109, syn@2.0.16, sync_wrapper@0.1.2, sysctl@0.5.4, tempfile@3.4.0, termcolor@1.2.0, textwrap@0.16.0, thiserror-impl@1.0.39, thiserror@1.0.39, tinyvec@1.6.0, tinyvec_macros@0.1.1, tokio-io-timeout@1.2.0, tokio-macros@2.0.0, tokio-stream@0.1.12, tokio-util@0.7.7, tokio@1.27.0, toml_datetime@0.6.1, toml_edit@0.19.4, tonic-build@0.10.2, tonic@0.10.2, tower-layer@0.3.2, tower-service@0.3.2, tower@0.4.13, tracing-attributes@0.1.23, tracing-core@0.1.30, tracing@0.1.37, trust-dns-proto@0.22.0, try-lock@0.2.4, typenum@1.16.0, uds_windows@1.0.2, unicode-bidi@0.3.10, unicode-ident@1.0.8, unicode-normalization@0.1.22, unicode-width@0.1.10, url@2.3.1, version_check@0.9.4, waker-fn@1.1.0, walkdir@2.3.2, want@0.3.0, wasi@0.11.0+wasi-snapshot-preview1, wasm-bindgen-backend@0.2.84, wasm-bindgen-macro-support@0.2.84, wasm-bindgen-macro@0.2.84, wasm-bindgen-shared@0.2.84, wasm-bindgen@0.2.84, wepoll-ffi@0.1.2, winapi-i686-pc-windows-gnu@0.4.0, winapi-util@0.1.5, winapi-x86_64-pc-windows-gnu@0.4.0, winapi@0.3.9, windows-sys@0.42.0, windows-sys@0.45.0, windows-targets@0.42.1, windows_aarch64_gnullvm@0.42.1, windows_aarch64_msvc@0.42.1, windows_i686_gnu@0.42.1, windows_i686_msvc@0.42.1, windows_x86_64_gnu@0.42.1, windows_x86_64_gnullvm@0.42.1, windows_x86_64_msvc@0.42.1, winnow@0.3.4, zbus@3.11.1, zbus_macros@3.11.1, zbus_names@2.5.0, zvariant@3.11.0, zvariant_derive@3.11.0, zvariant_utils@1.0.0
Homepage: https://github.com/containers/netavark
Vcs-Browser: https://salsa.debian.org/debian/netavark
Vcs-Git: https://salsa.debian.org/debian/netavark.git
Rules-Requires-Root: no

Package: netavark
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Provides: container-network-stack (= 2)
Recommends: aardvark-dns
Breaks: aardvark-dns (<< 1.4)
Enhances: podman
Description: Rust based network stack for containers
 Netavark is designed to work with but is also applicable
 for other OCI container management applications.

=== debian/rules ===
--- 
+++ 
@@ -8,6 +8,7 @@
 	dh $@ --buildsystem cargo
 
 execute_before_dh_auto_configure:
+	$(call _mkchecksum,debian/missing-sources/rustix/.cargo-checksum.json,Cargo.toml)
 	$(call _mkchecksum,debian/cargo-checksum.json,Cargo.toml)
 
 execute_after_dh_install:

=== debian/watch ===
version=4
opts="filenamemangle=s%.*/@ANY_VERSION@%@PACKAGE@-$1.tar.gz%,searchmode=plain" \
  https://api.github.com/repos/containers/netavark/tags?per_page=100 \
  https://api.github.com/repos/containers/netavark/tarball/refs/tags/@ANY_VERSION@

## netavark 1.9.0

=== debian/changelog ===
netavark (1.9.0-4) unstable; urgency=medium

  * Upload to unstable

 -- Reinhard Tartler <siretart@tauware.de>  Thu, 08 Aug 2024 07:03:51 -0400

netavark (1.9.0-3) experimental; urgency=medium

  * refresh patches
  * compile against rust-zbus 4.3, Closes: #1075895

 -- Reinhard Tartler <siretart@tauware.de>  Sat, 13 Jul 2024 20:42:28 -0400

netavark (1.9.0-2) experimental; urgency=medium

  * Upload to experimental

 -- Reinhard Tartler <siretart@tauware.de>  Sat, 13 Jul 2024 09:06:28 -0400

netavark (1.9.0-1) experimental; urgency=medium

  * New upstream version: 1.9.0

 -- Reinhard Tartler <siretart@tauware.de>  Sun, 14 Apr 2024 16:56:30 -0400

netavark (1.6.0-2.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Include patch to build with zbus 4.0; update d/control accordingly;
    amend relax-deps to accomodate zbus patching

 -- Matthias Geiger <werdahias@riseup.net>  Sun, 14 Jul 2024 19:15:16 +0200

netavark (1.4.0-4.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Apply upstream patch for new version of rust-nix (Closes: #1064580)
  * Relax cargo dependency on sysctl crate (Closes: #1069350)

 -- Peter Michael Green <plugwash@debian.org>  Thu, 02 May 2024 17:08:20 +0000

=== debian/control ===
Source: netavark
Section: net
Priority: optional
Maintainer: Reinhard Tartler <siretart@tauware.de>
Build-Depends: debhelper-compat (= 13),
 dh-cargo (>= 25),
 cargo:native <!nocheck>,
 librust-anyhow-dev,
 librust-atty-dev,
 librust-chrono-dev,
 librust-clap+derive-dev (>= 4.1),
 librust-env-logger-0.10-dev,
 librust-fs2-dev,
 librust-futures-dev,
 librust-http-dev (>= 0.2.11),
 librust-humantime-dev,
 librust-ipnet+serde-dev,
 librust-iptables-dev,
 librust-libc-dev,
 librust-log-dev,
 librust-macaddr-dev,
 librust-mozim-dev (>= 0.2.3),
 librust-netlink-packet-route-0.17-dev (>= 0.17.1),
 librust-nispor-dev,
 librust-nix-dev (>= 0.27),
 librust-prost-dev (>= 0.12),
 librust-rand-dev,
 librust-rtnetlink-dev,
 librust-rustversion-dev,
 librust-serde+derive-dev,
 librust-serde-json-dev,
 librust-serde-value-dev,
 librust-sha2-dev,
 librust-strsim-dev,
 librust-sysctl-dev (>= 0.5),
 librust-termcolor-dev,
 librust-tokio+full-dev,
 librust-tokio-stream-dev,
 librust-tonic-build-dev,
 librust-tonic-dev,
 librust-url-dev,
 librust-zbus-4-dev (>= 4.3.1),
 librust-zvariant-dev,
 libstd-rust-dev,
 rustc:native <!nocheck>,
Build-Conflicts:
 librust-zbus-1-dev,
Standards-Version: 4.7.0
Homepage: https://github.com/containers/netavark
Vcs-Browser: https://salsa.debian.org/debian/netavark
Vcs-Git: https://salsa.debian.org/debian/netavark.git
Rules-Requires-Root: no

Package: netavark
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Provides: container-network-stack (= 2)
Recommends: aardvark-dns
Breaks: aardvark-dns (<< 1.4)
Enhances: podman
Description: Rust based network stack for containers
 Netavark is designed to work with but is also applicable
 for other OCI container management applications.

## netavark 1.12.1

=== Makefile ===
--- 
+++ 
@@ -8,6 +8,7 @@
 PREFIX ?= /usr/local
 LIBEXECDIR ?= ${PREFIX}/libexec
 LIBEXECPODMAN ?= ${LIBEXECDIR}/podman
+SYSTEMDDIR ?= ${PREFIX}/lib/systemd/system
 
 SELINUXOPT ?= $(shell test -x /usr/sbin/selinuxenabled && selinuxenabled && echo -Z)
 # Get crate version by parsing the line that starts with version.
@@ -17,6 +18,9 @@
 # Set this to any non-empty string to enable unoptimized
 # build w/ debugging features.
 debug ?=
+
+# Set path to cargo executable
+CARGO ?= cargo
 
 # All complication artifacts, including dependencies and intermediates
 # will be stored here, for all architectures.  Use a non-default name
@@ -46,19 +50,26 @@
 	mkdir -p $@
 
 .PHONY: build
-build: bin $(CARGO_TARGET_DIR)
-	cargo build $(release)
+build: build_netavark build_proxy_client
+
+.PHONY: build_netavark
+build_netavark: bin $(CARGO_TARGET_DIR)
+	$(CARGO) build $(release)
 	cp $(CARGO_TARGET_DIR)/$(profile)/netavark bin/netavark$(if $(debug),.debug,)
+
+.PHONY: examples
+examples: bin $(CARGO_TARGET_DIR)
+	cargo build --examples $(release)
 
 .PHONY: crate-publish
 crate-publish:
-	@if [ "$(CRATE_VERSION)" != "$(GIT_TAG)" ]; then\
+	@if [ "v$(CRATE_VERSION)" != "$(GIT_TAG)" ]; then\
 		echo "Git tag is not equivalent to the version set in Cargo.toml. Please checkout the correct tag";\
 		exit 1;\
 	fi
 	@echo "It is expected that you have already done 'cargo login' before running this command. If not command may fail later"
-	cargo publish --dry-run
-	cargo publish
+	$(CARGO) publish --dry-run
+	$(CARGO) publish
 
 .PHONY: clean
 clean:
@@ -66,19 +77,37 @@
 	if [ "$(CARGO_TARGET_DIR)" = "targets" ]; then rm -rf targets; fi
 	$(MAKE) -C docs clean
 
+.PHONY: client
+client: bin $(CARGO_TARGET_DIR)
+	$(CARGO) build --bin netavark-dhcp-proxy-client $(release)
+
+
 .PHONY: docs
 docs: ## build the docs on the host
 	$(MAKE) -C docs
 
+NV_UNIT_FILES = contrib/systemd/system/netavark-dhcp-proxy.service \
+				contrib/systemd/system/netavark-firewalld-reload.service
+
+%.service: %.service.in
+	sed -e 's;@@NETAVARK@@;$(LIBEXECPODMAN)/netavark;g' $< >$@.tmp.$$ \
+		&& mv -f $@.tmp.$$ $@
+
 .PHONY: install
-install:
-	install ${SELINUXOPT} -D -m0755 bin/netavark $(DESTDIR)/$(LIBEXECPODMAN)/netavark
+install: $(NV_UNIT_FILES)
+	install ${SELINUXOPT} -D -m0755 bin/netavark $(DESTDIR)$(LIBEXECPODMAN)/netavark
 	$(MAKE) -C docs install
+	install ${SELINUXOPT} -m 755 -d ${DESTDIR}${SYSTEMDDIR}
+	install ${SELINUXOPT} -m 644 contrib/systemd/system/netavark-dhcp-proxy.socket ${DESTDIR}${SYSTEMDDIR}/netavark-dhcp-proxy.socket
+	install ${SELINUXOPT} -m 644 contrib/systemd/system/netavark-dhcp-proxy.service ${DESTDIR}${SYSTEMDDIR}/netavark-dhcp-proxy.service
+	install ${SELINUXOPT} -m 644 contrib/systemd/system/netavark-firewalld-reload.service ${DESTDIR}${SYSTEMDDIR}/netavark-firewalld-reload.service
 
 .PHONY: uninstall
 uninstall:
-	rm -f $(DESTDIR)/$(LIBEXECPODMAN)/netavark
+	rm -f $(DESTDIR)$(LIBEXECPODMAN)/netavark
 	rm -f $(PREFIX)/share/man/man1/netavark*.1
+	rm -f ${DESTDIR}${SYSTEMDDIR}/netavark-dhcp-proxy.service
+	rm -f ${DESTDIR}${SYSTEMDDIR}/netavark-dhcp-proxy.socket
 
 .PHONY: test
 test: unit integration
@@ -86,33 +115,35 @@
 # Used by CI to compile the unit tests but not run them
 .PHONY: build_unit
 build_unit: $(CARGO_TARGET_DIR)
-	cargo test --no-run
+	$(CARGO) test --no-run
 
 .PHONY: unit
 unit: $(CARGO_TARGET_DIR)
-	cargo test
+	$(CARGO) test
 
 .PHONY: integration
-integration: $(CARGO_TARGET_DIR)
+integration: $(CARGO_TARGET_DIR) examples
 	# needs to be run as root or with podman unshare --rootless-netns
 	bats test/
+	bats test-dhcp/
 
 .PHONY: validate
 validate: $(CARGO_TARGET_DIR)
-	cargo fmt --all -- --check
-	cargo clippy -p netavark -- -D warnings
+	$(CARGO) fmt --all -- --check
+	$(CARGO) clippy -p netavark@$(CRATE_VERSION) -- -D warnings
+	$(MAKE) docs
 
 .PHONY: vendor-tarball
 vendor-tarball: build install.cargo-vendor-filterer
 	VERSION=$(shell bin/netavark --version | cut -f2 -d" ") && \
-	cargo vendor-filterer '--platform=*-unknown-linux-*' --format=tar.gz --prefix vendor/ && \
+	$(CARGO) vendor-filterer --format=tar.gz --prefix vendor/ && \
 	mv vendor.tar.gz netavark-v$$VERSION-vendor.tar.gz && \
 	gzip -c bin/netavark > netavark.gz && \
 	sha256sum netavark.gz netavark-v$$VERSION-vendor.tar.gz > sha256sum
 
 .PHONY: install.cargo-vendor-filterer
 install.cargo-vendor-filterer:
-	cargo install cargo-vendor-filterer
+	$(CARGO) install cargo-vendor-filterer
 
 .PHONY: mock-rpm
 mock-rpm:
@@ -121,3 +152,8 @@
 .PHONY: help
 help:
 	@echo "usage: make $(prog) [debug=1]"
+
+.PHONY: build_proxy_client
+build_proxy_client: bin $(CARGO_TARGET_DIR)
+	$(CARGO) build --bin netavark-dhcp-proxy-client $(release)
+	cp $(CARGO_TARGET_DIR)/$(profile)/netavark-dhcp-proxy-client bin/netavark-dhcp-proxy-client$(if $(debug),.debug,)

=== debian/changelog ===
netavark (1.12.1-9) unstable; urgency=medium

  * Revert back to using uptables. Closes: #1092742, Reopens: #1091318

 -- Reinhard Tartler <siretart@tauware.de>  Sat, 11 Jan 2025 11:17:31 -0500

netavark (1.12.1-8) unstable; urgency=medium

  [ Reinhard Tartler ]
  * Restrict autopkgtests to amd64
  * default to nftables, closes: #1091318

  [ NoisyCoil ]
  * Bump env_logger dependency to v0.11, closes: #1091227

 -- Reinhard Tartler <siretart@tauware.de>  Wed, 01 Jan 2025 07:39:04 -0500

netavark (1.12.1-7) unstable; urgency=medium

  [ Tianyu Chen ]
  * Also move netavark-dhcp-proxy.socket to /usr/lib/systemd, Closes: #1087910

 -- Reinhard Tartler <siretart@tauware.de>  Wed, 20 Nov 2024 08:04:32 -0500

netavark (1.12.1-6) unstable; urgency=medium

  * Move systemd units to /usr/lib/systemd, Closes: #1087846

 -- Reinhard Tartler <siretart@tauware.de>  Tue, 19 Nov 2024 13:15:21 -0500

netavark (1.12.1-5) unstable; urgency=medium

  * autopkgtest: ignore the new bridge tests

 -- Reinhard Tartler <siretart@tauware.de>  Tue, 19 Nov 2024 08:05:41 -0500

netavark (1.12.1-4) unstable; urgency=medium

  * Install systemd service files, Closes: #1087796
    Thanks to Jonathan Steinert <debian@hachi.kuiki.net> for reporting!

 -- Reinhard Tartler <siretart@tauware.de>  Tue, 19 Nov 2024 07:03:52 -0500

netavark (1.12.1-3) unstable; urgency=medium

  * provide nftables to autopkgtests
  * Tests require 'ncat' as "netcat" implementation

 -- Reinhard Tartler <siretart@tauware.de>  Thu, 05 Sep 2024 21:28:47 -0400

netavark (1.12.1-2) unstable; urgency=medium

  * Upload to unstable

 -- Reinhard Tartler <siretart@tauware.de>  Mon, 02 Sep 2024 08:51:10 -0400

netavark (1.12.1-1) experimental; urgency=medium

  * New upstream release: 1.12.1
  * Refresh patches
  * Compile against clap 4.5, Closes: #1080118
  * Tighten dependencies on aardvark-dns 1.12
  * Require qemu for autopkgtest tests

 -- Reinhard Tartler <siretart@tauware.de>  Sat, 31 Aug 2024 08:31:56 -0400

netavark (1.9.0-5) unstable; urgency=medium

  * debian/tests/control: Add missing dependencies
  * Make autopkgtest pass
  * Relax dependency on rust-clap, Closes: #1080118
  * Normalize distro patches with gbp-pq export

 -- Reinhard Tartler <siretart@tauware.de>  Sat, 31 Aug 2024 18:29:28 -0400

=== debian/control ===
Source: netavark
Section: net
Priority: optional
Maintainer: Reinhard Tartler <siretart@tauware.de>
Build-Depends: cargo:native <!nocheck>,
               debhelper-compat (= 13),
               dh-cargo (>= 25),
               librust-anyhow-dev,
               librust-atty-dev,
               librust-chrono-dev,
               librust-clap+derive-dev (>= 4.1),
               librust-env-logger-0.11-dev,
               librust-fs2-dev,
               librust-futures-dev,
               librust-http-dev (>= 0.2.11),
               librust-humantime-dev,
               librust-ipnet+serde-dev,
               librust-iptables-dev,
               librust-libc-dev,
               librust-log-dev,
               librust-macaddr-dev,
               librust-mozim-dev (>= 0.2.3),
               librust-netlink-packet-route-0.17-dev (>= 0.17.1),
               librust-nftables-dev,
               librust-nispor-dev,
               librust-nix-dev (>= 0.27),
               librust-prost-dev (>= 0.12),
               librust-rand-dev,
               librust-rtnetlink-dev,
               librust-rustversion-dev,
               librust-serde+derive-dev,
               librust-serde-json-dev,
               librust-serde-value-dev,
               librust-sha2-dev,
               librust-strsim-dev,
               librust-sysctl-dev (>= 0.5),
               librust-termcolor-dev,
               librust-tokio+full-dev,
               librust-tokio-stream-dev,
               librust-tonic-build-dev,
               librust-tonic-dev,
               librust-url-dev,
               librust-zbus-4-dev (>= 4.3.1),
               librust-zvariant-dev,
               libstd-rust-dev,
               rustc:native <!nocheck>
Build-Conflicts: librust-zbus-1-dev
Standards-Version: 4.7.0
Homepage: https://github.com/containers/netavark
Vcs-Browser: https://salsa.debian.org/debian/netavark
Vcs-Git: https://salsa.debian.org/debian/netavark.git
Rules-Requires-Root: no

Package: netavark
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Provides: container-network-stack (= 2)
Recommends: aardvark-dns
Breaks: aardvark-dns (<< 1.12)
Enhances: podman
Description: Rust based network stack for containers
 Netavark is designed to work with but is also applicable
 for other OCI container management applications.

=== debian/rules ===
--- 
+++ 
@@ -8,9 +8,17 @@
 	dh $@ --buildsystem cargo
 
 execute_before_dh_auto_configure:
-	$(call _mkchecksum,debian/missing-sources/rustix/.cargo-checksum.json,Cargo.toml)
 	$(call _mkchecksum,debian/cargo-checksum.json,Cargo.toml)
 
 execute_after_dh_install:
-	mkdir -vp debian/netavark/usr/lib
+	mkdir -vp debian/netavark/usr/lib debian/netavark/usr/lib/systemd/system
 	mv -v debian/netavark/usr/bin debian/netavark/usr/lib/podman
+	install -D -m 664  contrib/systemd/system/netavark-dhcp-proxy.socket \
+		debian/netavark/usr/lib/systemd/system
+	sed -e 's;@@NETAVARK@@;/usr/lib/podman/netavark;g' \
+		< contrib/systemd/system/netavark-dhcp-proxy.service.in \
+		> debian/netavark/usr/lib/systemd/system/netavark-dhcp-proxy.service
+	sed -e 's;@@NETAVARK@@;/usr/lib/podman/netavark;g' \
+		< contrib/systemd/system/netavark-firewalld-reload.service.in \
+		> debian/netavark/usr/lib/systemd/system/netavark-firewalld-reload.service
+

## netavark 1.14.0

=== Makefile ===
--- 
+++ 
@@ -130,7 +130,7 @@
 .PHONY: validate
 validate: $(CARGO_TARGET_DIR)
 	$(CARGO) fmt --all -- --check
-	$(CARGO) clippy -p netavark@$(CRATE_VERSION) -- -D warnings
+	$(CARGO) clippy -p netavark -- -D warnings
 	$(MAKE) docs
 
 .PHONY: vendor-tarball

=== docs/Makefile ===
PREFIX ?= /usr/local
DATADIR ?= ${PREFIX}/share
MANDIR ?= $(DATADIR)/man
GO ?= go
GOMD2MAN ?= go-md2man

docs: $(patsubst %.md,%,$(wildcard *.[0-9].md))

%.1: %.1.md
	$(GOMD2MAN) -in $^ -out $@

%.7: %.7.md
	$(GOMD2MAN) -in $^ -out $@

.PHONY: .install.md2man
.install.md2man:
	$(GO) install github.com/cpuguy83/go-md2man/v2@latest

.PHONY: install
install:
	install -d ${DESTDIR}/${MANDIR}/man1
	install -m 0644 *.1 ${DESTDIR}/${MANDIR}/man1
	install -d ${DESTDIR}/${MANDIR}/man7
	install -m 0644 *.7 ${DESTDIR}/${MANDIR}/man7

.PHONY: clean
clean:
	$(RM) *.1

=== debian/changelog ===
netavark (1.14.0-2) unstable; urgency=medium

  * Delete patches no longer necessary
  * Bump Standards Version

 -- Reinhard Tartler <siretart@tauware.de>  Sun, 16 Mar 2025 16:40:52 -0400

netavark (1.14.0-1) experimental; urgency=medium

  * New upstream release
    - Builds against zbus v5, Closes: #1093690, #1099897
  * Default to nftables, again. Closes: #1091318

 -- Reinhard Tartler <siretart@tauware.de>  Mon, 17 Feb 2025 13:45:43 -0500

=== debian/control ===
--- 
+++ 
@@ -14,13 +14,14 @@
                librust-futures-dev,
                librust-http-dev (>= 0.2.11),
                librust-humantime-dev,
+               librust-hyper-util-dev,
                librust-ipnet+serde-dev,
                librust-iptables-dev,
                librust-libc-dev,
-               librust-log-dev,
+               librust-log-dev (>= 0.4.24),
                librust-macaddr-dev,
                librust-mozim-dev (>= 0.2.3),
-               librust-netlink-packet-route-0.17-dev (>= 0.17.1),
+               librust-netlink-packet-route-0.21-dev,
                librust-nftables-dev,
                librust-nispor-dev,
                librust-nix-dev (>= 0.27),
@@ -40,12 +41,12 @@
                librust-tonic-build-dev,
                librust-tonic-dev,
                librust-url-dev,
-               librust-zbus-4-dev (>= 4.3.1),
+               librust-zbus-dev,
                librust-zvariant-dev,
                libstd-rust-dev,
                rustc:native <!nocheck>
 Build-Conflicts: librust-zbus-1-dev
-Standards-Version: 4.7.0
+Standards-Version: 4.7.2
 Homepage: https://github.com/containers/netavark
 Vcs-Browser: https://salsa.debian.org/debian/netavark
 Vcs-Git: https://salsa.debian.org/debian/netavark.git
@@ -55,7 +56,7 @@
 Architecture: any
 Depends: ${misc:Depends}, ${shlibs:Depends}
 Provides: container-network-stack (= 2)
-Recommends: aardvark-dns
+Recommends: aardvark-dns, nftables
 Breaks: aardvark-dns (<< 1.12)
 Enhances: podman
 Description: Rust based network stack for containers

=== debian/rules ===
--- 
+++ 
@@ -1,4 +1,7 @@
 #!/usr/bin/make -f
+
+# cf. https://bugs.debian.org/cgi-bin/bugreport.cgi?bug=1091318
+export NETAVARK_DEFAULT_FW := nftables
 
 # generate cargo-checksum file
 _mkchecksum = printf '{"package":"%s","files":{}}\n' \

## netavark 1.16.1

=== Makefile ===
--- 
+++ 
@@ -19,8 +19,8 @@
 # build w/ debugging features.
 debug ?=
 
-# Set path to cargo executable
-CARGO ?= cargo
+# Set path to cargo executable, when running under CI make sure to add --locked so Cargo.lock is not modified
+CARGO ?= cargo $(if $(CI),--locked,)
 
 # All complication artifacts, including dependencies and intermediates
 # will be stored here, for all architectures.  Use a non-default name
@@ -28,6 +28,8 @@
 # places in the tool-chain (including 'make' itself).
 CARGO_TARGET_DIR ?= targets
 export CARGO_TARGET_DIR  # 'cargo' is sensitive to this env. var. value.
+
+SOURCES = $(shell find src/ -type f) Cargo.toml Cargo.lock Makefile
 
 ifdef debug
 $(info debug is $(debug))
@@ -41,7 +43,7 @@
 endif
 
 .PHONY: all
-all: build
+all: build docs
 
 bin:
 	mkdir -p $@
@@ -50,12 +52,14 @@
 	mkdir -p $@
 
 .PHONY: build
-build: build_netavark build_proxy_client
+build: bin/netavark
 
-.PHONY: build_netavark
-build_netavark: bin $(CARGO_TARGET_DIR)
+bin/netavark: $(SOURCES) bin $(CARGO_TARGET_DIR)
 	$(CARGO) build $(release)
-	cp $(CARGO_TARGET_DIR)/$(profile)/netavark bin/netavark$(if $(debug),.debug,)
+	cp $(CARGO_TARGET_DIR)/$(profile)/netavark bin/netavark
+	cp $(CARGO_TARGET_DIR)/$(profile)/netavark-dhcp-proxy-client bin/netavark-dhcp-proxy-client
+	cp $(CARGO_TARGET_DIR)/$(profile)/netavark-connection-tester bin/netavark-connection-tester
+
 
 .PHONY: examples
 examples: bin $(CARGO_TARGET_DIR)
@@ -74,6 +78,7 @@
 .PHONY: clean
 clean:
 	rm -rf bin
+	rm -rf vendor-tarball
 	if [ "$(CARGO_TARGET_DIR)" = "targets" ]; then rm -rf targets; fi
 	$(MAKE) -C docs clean
 
@@ -104,10 +109,12 @@
 
 .PHONY: uninstall
 uninstall:
+	$(MAKE) -C docs uninstall
 	rm -f $(DESTDIR)$(LIBEXECPODMAN)/netavark
 	rm -f $(PREFIX)/share/man/man1/netavark*.1
 	rm -f ${DESTDIR}${SYSTEMDDIR}/netavark-dhcp-proxy.service
 	rm -f ${DESTDIR}${SYSTEMDDIR}/netavark-dhcp-proxy.socket
+	rm -f ${DESTDIR}${SYSTEMDDIR}/netavark-firewalld-reload.service
 
 .PHONY: test
 test: unit integration
@@ -137,8 +144,10 @@
 vendor-tarball: build install.cargo-vendor-filterer
 	VERSION=$(shell bin/netavark --version | cut -f2 -d" ") && \
 	$(CARGO) vendor-filterer --format=tar.gz --prefix vendor/ && \
-	mv vendor.tar.gz netavark-v$$VERSION-vendor.tar.gz && \
-	gzip -c bin/netavark > netavark.gz && \
+	mkdir -p vendor-tarball && \
+	mv vendor.tar.gz vendor-tarball/netavark-v$$VERSION-vendor.tar.gz && \
+	gzip -c bin/netavark > vendor-tarball/netavark.gz && \
+	cd vendor-tarball && \
 	sha256sum netavark.gz netavark-v$$VERSION-vendor.tar.gz > sha256sum
 
 .PHONY: install.cargo-vendor-filterer
@@ -152,8 +161,3 @@
 .PHONY: help
 help:
 	@echo "usage: make $(prog) [debug=1]"
-
-.PHONY: build_proxy_client
-build_proxy_client: bin $(CARGO_TARGET_DIR)
-	$(CARGO) build --bin netavark-dhcp-proxy-client $(release)
-	cp $(CARGO_TARGET_DIR)/$(profile)/netavark-dhcp-proxy-client bin/netavark-dhcp-proxy-client$(if $(debug),.debug,)

=== docs/Makefile ===
--- 
+++ 
@@ -17,12 +17,17 @@
 	$(GO) install github.com/cpuguy83/go-md2man/v2@latest
 
 .PHONY: install
-install:
+install: docs
 	install -d ${DESTDIR}/${MANDIR}/man1
 	install -m 0644 *.1 ${DESTDIR}/${MANDIR}/man1
 	install -d ${DESTDIR}/${MANDIR}/man7
 	install -m 0644 *.7 ${DESTDIR}/${MANDIR}/man7
 
+.PHONY: uninstall
+uninstall:
+	rm -f ${DESTDIR}/${MANDIR}/man1/*.1
+	rm -f ${DESTDIR}/${MANDIR}/man7/*.7
+
 .PHONY: clean
 clean:
-	$(RM) *.1
+	$(RM) *.1 *.7

=== debian/changelog ===
netavark (1.16.1-3) unstable; urgency=medium

  * salsa-ci: Disable reprotest
  * Build against nix-0.30, Closes: #1116542

 -- Reinhard Tartler <siretart@tauware.de>  Sat, 18 Oct 2025 05:48:04 -0400

netavark (1.16.1-2) unstable; urgency=medium

  * Upload to unstable

 -- Reinhard Tartler <siretart@tauware.de>  Thu, 11 Sep 2025 05:59:45 -0400

netavark (1.16.1-1) experimental; urgency=medium

  * New upstream release 1.16
  * Refresh patches
    - Relax dependency on clap, env_logger, hyper-util, nix, sysctl, rand,
      prost, zbus, chronos
    - build against netlink-packet-route 0.23
  * build against nftables in experimental, Closes: #1112210

 -- Reinhard Tartler <siretart@tauware.de>  Mon, 01 Sep 2025 11:36:37 -0400

=== debian/control ===
--- 
+++ 
@@ -21,8 +21,8 @@
                librust-log-dev (>= 0.4.24),
                librust-macaddr-dev,
                librust-mozim-dev (>= 0.2.3),
-               librust-netlink-packet-route-0.21-dev,
-               librust-nftables-dev,
+               librust-netlink-packet-route-0.23-dev,
+               librust-nftables-dev (>= 0.6.3),
                librust-nispor-dev,
                librust-nix-dev (>= 0.27),
                librust-prost-dev (>= 0.12),

=== debian/tests/control ===
# Bridge tests fail, cf https://github.com/containers/netavark/issues/984
Test-Command: rm -fv test/1??-* test/2??-* test/500-*; env NETAVARK=/usr/lib/podman/netavark bats --no-tempdir-cleanup --print-output-on-failure test/
Features: test-name=system-tests:@
Architecture: amd64
Depends: aardvark-dns (>> 1.12),
         bats,
         bind9-dnsutils,
         firewalld,
         iproute2,
         iptables,
         iputils-ping,
         jq,
         ncat,
         nftables,
         util-linux,
         @
Restrictions: allow-stderr, isolation-machine, needs-root

=== debian/watch ===
version=4
opts="filenamemangle=s%.*/@ANY_VERSION@%@PACKAGE@-$1.tar.gz%,searchmode=plain" \
  https://api.github.com/repos/containers/netavark/tags?per_page=100 \
  https://api.github.com/repos/containers/netavark/tarball/refs/tags/@ANY_VERSION@
